/*  $Id: broadcast_vr_change_dlg.hpp 22029 2010-09-07 13:25:34Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Yury Voronov
 *
 * File Description:
 *
 */

// Generated by DialogBlocks (unregistered), 24/03/2009 16:27:45

#ifndef _BROADCAST_VR_CHANGE_DLG_H_
#define _BROADCAST_VR_CHANGE_DLG_H_


/*!
 * Includes
 */

#include <corelib/ncbistd.hpp>

////@begin includes
#include <wx/valgen.h>
#include <wx/statline.h>
////@end includes

#include <wx/dialog.h>
#include <wx/checkbox.h>

BEGIN_NCBI_SCOPE

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CBROADCASTVRCHANGEDIALOG_STYLE wxCAPTION|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CBROADCASTVRCHANGEDIALOG_TITLE _("Broadcast VR Change ")
#define SYMBOL_CBROADCASTVRCHANGEDIALOG_IDNAME ID_CBROADCASTVRCHANGE
#define SYMBOL_CBROADCASTVRCHANGEDIALOG_SIZE wxSize(400, 300)
#define SYMBOL_CBROADCASTVRCHANGEDIALOG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CBroadcastVRChangeDialog class declaration
 */

class CBroadcastVRChangeDialog: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CBroadcastVRChangeDialog )
    DECLARE_EVENT_TABLE()

public:
    CBroadcastVRChangeDialog();
    CBroadcastVRChangeDialog( wxWindow* parent, wxWindowID id = SYMBOL_CBROADCASTVRCHANGEDIALOG_IDNAME, const wxString& caption = SYMBOL_CBROADCASTVRCHANGEDIALOG_TITLE, const wxPoint& pos = SYMBOL_CBROADCASTVRCHANGEDIALOG_POSITION, const wxSize& size = SYMBOL_CBROADCASTVRCHANGEDIALOG_SIZE, long style = SYMBOL_CBROADCASTVRCHANGEDIALOG_STYLE );

    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CBROADCASTVRCHANGEDIALOG_IDNAME, const wxString& caption = SYMBOL_CBROADCASTVRCHANGEDIALOG_TITLE, const wxPoint& pos = SYMBOL_CBROADCASTVRCHANGEDIALOG_POSITION, const wxSize& size = SYMBOL_CBROADCASTVRCHANGEDIALOG_SIZE, long style = SYMBOL_CBROADCASTVRCHANGEDIALOG_STYLE );

    ~CBroadcastVRChangeDialog();

    void Init();

    void CreateControls();

////@begin CBroadcastVRChangeDialog event handler declarations

    void OnByDefaultClick( wxCommandEvent& event );

////@end CBroadcastVRChangeDialog event handler declarations

////@begin CBroadcastVRChangeDialog member function declarations

    bool GetByDefault() const { return mf_ByDefault ; }
    void SetByDefault(bool value) { mf_ByDefault = value ; }

    wxBitmap GetBitmapResource( const wxString& name );

    wxIcon GetIconResource( const wxString& name );
////@end CBroadcastVRChangeDialog member function declarations

    int GetBroadcastFlag() const;
    void SetBroadcastFlag( int value );
    void ResetRadioButtons( bool show );
    
    static bool ShowToolTips();

////@begin CBroadcastVRChangeDialog member variables
    wxCheckBox* m_ByDefault;
private:
    bool mf_ByDefault;
    bool m_BroadcastFlags[5];
    enum {
        ID_CBROADCASTVRCHANGE = 10040,
        ID_CHECKBOX = 10043,
        ID_RADIOBUTTON1 = 10001,
        ID_RADIOBUTTON2 = 10002,
        ID_RADIOBUTTON3 = 10003,
        ID_RADIOBUTTON4 = 10004,
        ID_RADIOBUTTON5 = 10005,
        ID_STATICLINE2 = 10028
    };
////@end CBroadcastVRChangeDialog member variables
};

END_NCBI_SCOPE

#endif
    // _BROADCAST_VR_CHANGE_DLG_H_
