/* $Id: GBenchFeedbackRequest.hpp 20229 2009-10-19 16:18:06Z voronov $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file GBenchFeedbackRequest.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'gbench_svc.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: GBenchFeedbackRequest_.hpp


#ifndef GUI_CORE_GBENCHFEEDBACKREQUEST_HPP
#define GUI_CORE_GBENCHFEEDBACKREQUEST_HPP


// generated includes
#include <gui/objects/GBenchFeedbackRequest_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_GUIOBJECTS_EXPORT CGBenchFeedbackRequest : public CGBenchFeedbackRequest_Base
{
    typedef CGBenchFeedbackRequest_Base Tparent;
public:
    // constructor
    CGBenchFeedbackRequest(void);
    // destructor
    ~CGBenchFeedbackRequest(void);

    /// each of these fields is stored as a zlib-compressed entity
    /// to reduce the traffic

    /// decompressors
    void DecodeDesc      (string& desc) const;
    void DecodeApp_log   (string& app_log) const;
    void DecodeSys_config(string& app_log) const;

    /// compressors
    void EncodeDesc(const string& str);
    void EncodeDesc(CNcbiIstream& istr);

    void EncodeApp_log(const string& str);
    void EncodeApp_log(CNcbiIstream& istr);

    void EncodeSys_config(const string& str);
    void EncodeSys_config(CNcbiIstream& istr);


private:
    // Prohibit copy constructor and assignment operator
    CGBenchFeedbackRequest(const CGBenchFeedbackRequest& value);
    CGBenchFeedbackRequest& operator=(const CGBenchFeedbackRequest& value);

};

/////////////////// end of CGBenchFeedbackRequest inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

#endif // GUI_CORE_GBENCHFEEDBACKREQUEST_HPP
/* Original file checksum: lines: 94, chars: 2788, CRC32: da3b097c */
