/* $Id: PluginReply.hpp 14666 2007-07-09 13:40:22Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Author:  .......
 *
 * File Description:
 *   .......
 *
 * Remark:
 *   This code was originally generated by application DATATOOL
 *   using specifications from the data definition file
 *   'plugin.asn'.
 */

#ifndef GUI_PLUGIN_PLUGINREPLY_HPP
#define GUI_PLUGIN_PLUGINREPLY_HPP


// generated includes
#include <gui/objects/PluginReply_.hpp>
#include <gui/objects/PluginReplyAction.hpp>
#include <gui/objutils/objects.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE /// namespace ncbi::objects::

class CGBProjectHandle;


class NCBI_GUIOBJECTS_EXPORT CPluginReply : public CPluginReply_Base
{
    typedef CPluginReply_Base Tparent;
public:
    /// constructor
    CPluginReply(void);
    /// destructor
    ~CPluginReply(void);

    /// add an action to be undertaken when processing this reply
    void AddAction(CPluginReplyAction::E_Choice choice,
                   const string& opts = "");

    /// add an object to this reply's raw object list
    void AddObject(const CObject& object, const CGBProjectHandle* project = NULL);

    /// add a document to the reply's raw object list.
    void AddObject(const CGBProjectHandle& project);

    /// Create a set of object-scope pairs for the raw reply
    TConstScopedObjects DecomposeRaw() const;

private:
    /// Prohibit copy constructor and assignment operator
    CPluginReply(const CPluginReply& value);
    CPluginReply& operator=(const CPluginReply& value);

};



/////////////////// CPluginReply inline methods

// constructor
inline
CPluginReply::CPluginReply(void)
{
}


/////////////////// end of CPluginReply inline methods


END_objects_SCOPE /// namespace ncbi::objects::

END_NCBI_SCOPE

#endif /// GUI_PLUGIN_PLUGINREPLY_HPP
/* Original file checksum: lines: 93, chars: 2435, CRC32: 4690fea4 */
