#ifndef GUI_OBJUTILS___DOI_LOOKUP__HPP
#define GUI_OBJUTILS___DOI_LOOKUP__HPP

/*  $Id: doi_lookup.hpp 46163 2021-01-27 01:32:34Z evgeniev $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors: Igor Filippov
 *
 * File Description:
 *
 */
#include <corelib/ncbistd.hpp>
#include <gui/gui_export.h>
#include <objects/seq/Pubdesc.hpp>

BEGIN_NCBI_SCOPE

class NCBI_GUIOBJUTILS_EXPORT CDoiLookup
{
public:
static string GetSpecialCharacterReplacement(TUnicodeSymbol ch);
static pair<CRef<objects::CPubdesc>, string> GetPubFromCrossRef(const string &doi);
static string Transcode(const CStringUTF8 &input);
static void LookupIsojta(string old_title, vector<string> &titles);
};

END_NCBI_SCOPE

#endif  // GUI_OBJUTILS___DOI_LOOKUP__HPP
