#ifndef _LOADENTREZ_SEQ_DLG_H_
#define _LOADENTREZ_SEQ_DLG_H_
/*  $Id: loadentrez_seq_dlg.hpp 35961 2016-07-19 20:41:20Z asztalos $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Andrea Asztalos
 */
// Generated by DialogBlocks (unregistered), 19/02/2015 14:08:09

#include <corelib/ncbistd.hpp>
#include <wx/dialog.h>

class wxTextCtrl;

BEGIN_NCBI_SCOPE
BEGIN_SCOPE(objects)
    class CSeq_id;
END_SCOPE(objects)
/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CLOADSEQFROMENTREZ_DLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CLOADSEQFROMENTREZ_DLG_TITLE _("Download From Entrez")
#define SYMBOL_CLOADSEQFROMENTREZ_DLG_IDNAME ID_CLOADSEQFROMENTREZ_DLG
#define SYMBOL_CLOADSEQFROMENTREZ_DLG_SIZE wxSize(400, 300)
#define SYMBOL_CLOADSEQFROMENTREZ_DLG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CLoadSeqFromEntrez_dlg class declaration
 */

class CLoadSeqFromEntrez_dlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CLoadSeqFromEntrez_dlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CLoadSeqFromEntrez_dlg();
    CLoadSeqFromEntrez_dlg( wxWindow* parent,
        wxWindowID id = SYMBOL_CLOADSEQFROMENTREZ_DLG_IDNAME, 
        const wxString& caption = SYMBOL_CLOADSEQFROMENTREZ_DLG_TITLE, 
        const wxPoint& pos = SYMBOL_CLOADSEQFROMENTREZ_DLG_POSITION, 
        const wxSize& size = SYMBOL_CLOADSEQFROMENTREZ_DLG_SIZE, 
        long style = SYMBOL_CLOADSEQFROMENTREZ_DLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, 
        wxWindowID id = SYMBOL_CLOADSEQFROMENTREZ_DLG_IDNAME, 
        const wxString& caption = SYMBOL_CLOADSEQFROMENTREZ_DLG_TITLE, 
        const wxPoint& pos = SYMBOL_CLOADSEQFROMENTREZ_DLG_POSITION, 
        const wxSize& size = SYMBOL_CLOADSEQFROMENTREZ_DLG_SIZE, 
        long style = SYMBOL_CLOADSEQFROMENTREZ_DLG_STYLE );

    /// Destructor
    ~CLoadSeqFromEntrez_dlg();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CLoadSeqFromEntrez_dlg event handler declarations

    /// wxEVT_UPDATE_UI event handler for wxID_OK
    void OnTextChange( wxUpdateUIEvent& event );

    void OnTextCtrlEnter( wxCommandEvent& event );
////@end CLoadSeqFromEntrez_dlg event handler declarations

////@begin CLoadSeqFromEntrez_dlg member function declarations
    string GetData() const;

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CLoadSeqFromEntrez_dlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();
private:
////@begin CLoadSeqFromEntrez_dlg member variables
    wxTextCtrl* m_Text;
    /// Control identifiers
    enum {
        ID_CLOADSEQFROMENTREZ_DLG = 10438,
        ID_LDTEXT = 10441
    };
////@end CLoadSeqFromEntrez_dlg member variables
};

END_NCBI_SCOPE

#endif
    // _LOADENTREZ_SEQ_DLG_H_
