#ifndef _GUI_PACKAGES_FIELD_TYPE_CONSTANTS_HPP_
#define _GUI_PACKAGES_FIELD_TYPE_CONSTANTS_HPP_
/*  $Id: field_type_constants.hpp 43676 2019-08-14 14:28:05Z asztalos $
* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data,  the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties,  express or implied,  including
*  warranties of performance,  merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================
*
* Authors:  Andrea Asztalos
* 
*/

#include <corelib/ncbistd.hpp>
#include <gui/gui_export.h>

BEGIN_NCBI_SCOPE


NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kDefinitionLineLabel;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kCommentDescriptorLabel;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kGenomeProjectID;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kGenbankBlockKeyword;

NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kFieldTypeSeqId;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kFileSeqId;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kGeneralId;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kLocalId;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kFlatFile;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kBankITComment;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kComment;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kTaxnameAfterBinomial;

NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kFieldTypeTaxname;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kStructCommFieldValuePair;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kStructCommDBName;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kStructCommFieldName;

NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kSubSourceNote;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kOrgModNote;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kHost;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kNatHost;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kAllNotes;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kAllPrimers;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kDbXref;

NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kFwdPrimerName;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kFwdPrimerSeq;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kRevPrimerName;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kRevPrimerSeq;

NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kNewId;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kMoleculeType;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kDefaultMoleculeType;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kTopology;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kLocation;
NCBI_GUIWIDGETS_EDIT_EXPORT extern const char* kSequenceIdColLabel;

END_NCBI_SCOPE

#endif
        // _GUI_PACKAGES_FIELD_TYPE_CONSTANTS_HPP_
