#ifndef GUI_WIDGETS___LOADERS___COLUMNAR_VCF_CACHE__HPP_
#define GUI_WIDGETS___LOADERS___COLUMNAR_VCF_CACHE__HPP_
/*  $Id: columnar_vcf_cache.hpp 46098 2021-01-22 21:44:41Z evgeniev $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Vladislav Evgeniev
 *
 * File Description:
 *   
 *
 */

#include <gui/gui_export.h>

#include <gui/widgets/loaders/data_crawler_cache.hpp>

BEGIN_NCBI_SCOPE

class NCBI_GUIWIDGETS_LOADERS_EXPORT CColumnarVcfCache : public CDataCrawlerCache
{
public:
    CColumnarVcfCache(const std::string &url, const std::string &seq_id);

protected:
    /// @name CDataCrawlerCache overridables
    /// @{
    virtual CNetICacheClient x_InitBlobCache();
    virtual CNetICacheClient x_InitSyncCache();
    virtual std::string x_GetCacheKey();
    /// @}

private:
    std::string m_Url;
    std::string m_SeqId;
};

END_NCBI_SCOPE

#endif // GUI_WIDGETS___LOADERS___COLUMNAR_VCF_CACHE__HPP_
