/*
*  $Id: PSeq.cpp 108119 2007-08-02 18:20:35Z chetvern $
*
* =========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannt warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* =========================================================================
*
*  Author: Boris Kiryutin
*
* =========================================================================
*/

#include <ncbi_pch.hpp>
#include <corelib/ncbistd.hpp>

#include "PSeq.hpp"
#include <objmgr/seq_vector.hpp>
#include <objmgr/seq_vector_ci.hpp>
#include <objects/seqloc/Seq_loc.hpp>

BEGIN_NCBI_SCOPE
BEGIN_SCOPE(prosplign)

CPSeq::CPSeq(CScope& scope, const CSeq_id& protein)
{
    CSeq_loc seqloc;
    seqloc.SetWhole().Assign(protein);
    CSeqVector seq_vec(seqloc,scope,CBioseq_Handle::eCoding_Iupac);
    for (CSeqVector_CI i(seq_vec); i; ++i) {
        seq.push_back(*i);
    }
}

CPSeq::~CPSeq(void)
{
}

END_SCOPE(prosplign)
END_NCBI_SCOPE
