#ifndef GUI_APP_GBENCH_NEW___PAGER_MESSAGE_DLG__HPP
#define GUI_APP_GBENCH_NEW___PAGER_MESSAGE_DLG__HPP

/*  $Id: pager_message_dlg.hpp 43918 2019-09-18 20:36:22Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 */
// Generated by DialogBlocks (unregistered), 17/09/2019 16:32:41

#include <corelib/ncbistd.hpp>

/*!
 * Includes
 */

#include <gui/widgets/wx/dialog.hpp>

////@begin includes
#include "wx/html/htmlwin.h"
#include "wx/valgen.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CPAGERMESSAGEDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CPAGERMESSAGEDLG_TITLE _("Genome Workbench Message")
#define SYMBOL_CPAGERMESSAGEDLG_IDNAME ID_CPAGERMESSAGEDLG
#define SYMBOL_CPAGERMESSAGEDLG_SIZE wxSize(400, 300)
#define SYMBOL_CPAGERMESSAGEDLG_POSITION wxDefaultPosition
////@end control identifiers

BEGIN_NCBI_SCOPE

/*!
 * CPagerMessageDlg class declaration
 */

class CPagerMessageDlg: public CDialog
{    
    DECLARE_DYNAMIC_CLASS( CPagerMessageDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CPagerMessageDlg();
    CPagerMessageDlg( wxWindow* parent, wxWindowID id = SYMBOL_CPAGERMESSAGEDLG_IDNAME, const wxString& caption = SYMBOL_CPAGERMESSAGEDLG_TITLE, const wxPoint& pos = SYMBOL_CPAGERMESSAGEDLG_POSITION, const wxSize& size = SYMBOL_CPAGERMESSAGEDLG_SIZE, long style = SYMBOL_CPAGERMESSAGEDLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CPAGERMESSAGEDLG_IDNAME, const wxString& caption = SYMBOL_CPAGERMESSAGEDLG_TITLE, const wxPoint& pos = SYMBOL_CPAGERMESSAGEDLG_POSITION, const wxSize& size = SYMBOL_CPAGERMESSAGEDLG_SIZE, long style = SYMBOL_CPAGERMESSAGEDLG_STYLE );

    /// Destructor
    ~CPagerMessageDlg();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CPagerMessageDlg event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_FEEDBACK_BTM
    void OnFeedbackBtmClick( wxCommandEvent& event );

////@end CPagerMessageDlg event handler declarations

////@begin CPagerMessageDlg member function declarations

    bool GetDoNotShow() const { return m_DoNotShow ; }
    void SetDoNotShow(bool value) { m_DoNotShow = value ; }

    wxString GetHTML() const { return m_HTML ; }
    void SetHTML(wxString value) { m_HTML = value ; }

    bool GetOpenFeedback() const { return m_OpenFeedback ; }
    void SetOpenFeedback(bool value) { m_OpenFeedback = value ; }

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CPagerMessageDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CPagerMessageDlg member variables
private:
    bool m_DoNotShow;
    wxString m_HTML;
    bool m_OpenFeedback;
    /// Control identifiers
    enum {
        ID_CPAGERMESSAGEDLG = 10000,
        ID_HTMLWINDOW = 10001,
        ID_CHECKBOX = 10002,
        ID_FEEDBACK_BTM = 10003
    };
////@end CPagerMessageDlg member variables
};

END_NCBI_SCOPE

#endif  // GUI_APP_GBENCH_NEW___PAGER_MESSAGE_DLG__HPP
