/*  $Id: advanced_cleanup_params_panel.hpp 44031 2019-10-10 14:41:41Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors: Roman Katargin
 *
 * File Description:
 *
 */

// Generated by DialogBlocks (unregistered), 16/09/2019 14:29:11

#ifndef _ADVANCED_CLEANUP_PARAMS_PANEL_H_
#define _ADVANCED_CLEANUP_PARAMS_PANEL_H_


/*!
 * Includes
 */

#include <gui/core/algo_tool_manager_base.hpp>

////@begin includes
#include "advanced_cleanup_params.hpp"
#include "wx/listctrl.h"
#include "wx/valgen.h"
////@end includes

BEGIN_NCBI_SCOPE

/*!
 * Forward declarations
 */

////@begin forward declarations
class CObjectListWidget;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_STYLE wxTAB_TRAVERSAL
#define SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_TITLE _("CAdvancedCleanupParamsPanel")
#define SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_IDNAME ID_CADVANCEDCLEANUPPARAMSPANEL
#define SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_SIZE wxSize(400, 300)
#define SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CAdvancedCleanupParamsPanel class declaration
 */

class CAdvancedCleanupParamsPanel: public CAlgoToolManagerParamsPanel
{    
    DECLARE_DYNAMIC_CLASS( CAdvancedCleanupParamsPanel )
    DECLARE_EVENT_TABLE()

public:
    CAdvancedCleanupParamsPanel();
    CAdvancedCleanupParamsPanel( wxWindow* parent, wxWindowID id = SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_IDNAME, const wxPoint& pos = SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_POSITION, const wxSize& size = SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_SIZE, long style = SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_STYLE );

    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_IDNAME, const wxPoint& pos = SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_POSITION, const wxSize& size = SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_SIZE, long style = SYMBOL_CADVANCEDCLEANUPPARAMSPANEL_STYLE );

    ~CAdvancedCleanupParamsPanel();

    void Init();

    void CreateControls();

    void SetObjects(TConstScopedObjects* objects);

    /// @name CAlgoToolManagerParamsPanel implementation
    void RestoreDefaults();
    /// @}

    virtual void    SetRegistryPath(const string& path);
    virtual void    LoadSettings();
    virtual void    SaveSettings() const;

    virtual bool TransferDataToWindow();

    virtual bool TransferDataFromWindow();

////@begin CAdvancedCleanupParamsPanel event handler declarations

////@end CAdvancedCleanupParamsPanel event handler declarations

////@begin CAdvancedCleanupParamsPanel member function declarations

    CAdvancedCleanupParams& GetData() { return m_data; }
    const CAdvancedCleanupParams& GetData() const { return m_data; }
    void SetData(const CAdvancedCleanupParams& data) { m_data = data; }

    wxBitmap GetBitmapResource( const wxString& name );

    wxIcon GetIconResource( const wxString& name );
////@end CAdvancedCleanupParamsPanel member function declarations

    static bool ShowToolTips();

////@begin CAdvancedCleanupParamsPanel member variables
    CObjectListWidget* m_ObjectList;
    CAdvancedCleanupParams m_data;
    enum {
        ID_CADVANCEDCLEANUPPARAMSPANEL = 10000,
        ID_LISTCTRL2 = 10014,
        ID_CHOICE = 10001,
        ID_CHOICE1 = 10002,
        ID_CHECKBOX = 10003
    };
////@end CAdvancedCleanupParamsPanel member variables

    string  m_RegPath;
};

END_NCBI_SCOPE

#endif
    // _ADVANCED_CLEANUP_PARAMS_PANEL_H_
