/*  $Id: citations_panel.hpp 25028 2012-01-12 17:26:13Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Colleen Bollin
 */
// Generated by DialogBlocks (unregistered), 29/12/2011 15:47:45

#ifndef _CITATIONS_PANEL_H_
#define _CITATIONS_PANEL_H_

#include <corelib/ncbistd.hpp>

/*!
 * Includes
 */

////@begin includes
////@end includes

#include <objects/seqfeat/Seq_feat.hpp>
#include <objects/pub/Pub.hpp>
#include <objmgr/scope.hpp>

#include "wx/checkbox.h"
#include <wx/scrolwin.h>
#include <wx/sizer.h>
#include "wx/combobox.h"


/*!
 * Forward declarations
 */

////@begin forward declarations
class wxBoxSizer;
////@end forward declarations

BEGIN_NCBI_SCOPE

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CCITATIONSPANEL_STYLE wxTAB_TRAVERSAL
#define SYMBOL_CCITATIONSPANEL_TITLE _("CitationsPanel")
#define SYMBOL_CCITATIONSPANEL_IDNAME ID_CCITATIONSPANEL
#define SYMBOL_CCITATIONSPANEL_SIZE wxSize(400, 300)
#define SYMBOL_CCITATIONSPANEL_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CCitationsPanel class declaration
 */

class CCitationsPanel: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CCitationsPanel )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CCitationsPanel();
    CCitationsPanel( wxWindow* parent, objects::CSeq_feat& seq_feat, objects::CScope& scope,
                     wxWindowID id = SYMBOL_CCITATIONSPANEL_IDNAME, const wxPoint& pos = SYMBOL_CCITATIONSPANEL_POSITION, const wxSize& size = SYMBOL_CCITATIONSPANEL_SIZE, long style = SYMBOL_CCITATIONSPANEL_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CCITATIONSPANEL_IDNAME, const wxPoint& pos = SYMBOL_CCITATIONSPANEL_POSITION, const wxSize& size = SYMBOL_CCITATIONSPANEL_SIZE, long style = SYMBOL_CCITATIONSPANEL_STYLE );

    /// Destructor
    ~CCitationsPanel();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

    virtual bool TransferDataToWindow();
    virtual bool TransferDataFromWindow();

    void SetCitations(objects::CSeq_feat& seq_feat);

////@begin CCitationsPanel event handler declarations

////@end CCitationsPanel event handler declarations

////@begin CCitationsPanel member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CCitationsPanel member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CCitationsPanel member variables
    wxScrolledWindow* m_ScrolledWindow;
    wxBoxSizer* m_Sizer;
    /// Control identifiers
    enum {
        ID_CCITATIONSPANEL = 10107,
        ID_SCROLLEDWINDOW5 = 10108
    };
////@end CCitationsPanel member variables
    CRef<objects::CSeq_feat> m_EditedFeat;
    objects::CScope *m_Scope;
    vector<CRef<objects::CPub> > m_PubList;
    vector<wxCheckBox*> m_Checkboxes;
};

END_NCBI_SCOPE

#endif
    // _CITATIONS_PANEL_H_
