/*  $Id: experiments_panel.hpp 28085 2013-05-07 17:27:58Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Colleen Bollin
 */
// Generated by DialogBlocks (unregistered), 07/12/2011 12:04:08

#ifndef _EXPERIMENTS_PANEL_H_
#define _EXPERIMENTS_PANEL_H_

#include <corelib/ncbistd.hpp>
#include <objects/seqfeat/Gb_qual.hpp>

#include <wx/panel.h>
#include <wx/frame.h>
#include <wx/sizer.h>
#include <wx/bitmap.h>
#include <wx/icon.h>
#include <wx/choice.h>
#include <wx/textctrl.h>
#include <wx/stattext.h>
#include <wx/valtext.h>
#include <wx/scrolwin.h>

/*!
 * Includes
 */

////@begin includes
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

BEGIN_NCBI_SCOPE

BEGIN_SCOPE(objects) // namespace ncbi::objects::
class CScope;
END_SCOPE(objects)

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CEXPERIMENTSPANEL_STYLE wxTAB_TRAVERSAL
#define SYMBOL_CEXPERIMENTSPANEL_TITLE _("Experiments Panel")
#define SYMBOL_CEXPERIMENTSPANEL_IDNAME ID_CEXPERIMENTSSPANEL
#define SYMBOL_CEXPERIMENTSPANEL_SIZE wxSize(266, 184)
#define SYMBOL_CEXPERIMENTSPANEL_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CExperimentsPanel class declaration
 */

class CExperimentsPanel: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CExperimentsPanel )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CExperimentsPanel();
    CExperimentsPanel( wxWindow* parent, CSerialObject& object,
		               wxWindowID id = SYMBOL_CEXPERIMENTSPANEL_IDNAME, const wxPoint& pos = SYMBOL_CEXPERIMENTSPANEL_POSITION, const wxSize& size = SYMBOL_CEXPERIMENTSPANEL_SIZE, long style = SYMBOL_CEXPERIMENTSPANEL_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CEXPERIMENTSPANEL_IDNAME, const wxPoint& pos = SYMBOL_CEXPERIMENTSPANEL_POSITION, const wxSize& size = SYMBOL_CEXPERIMENTSPANEL_SIZE, long style = SYMBOL_CEXPERIMENTSPANEL_STYLE );

    /// Destructor
    ~CExperimentsPanel();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CExperimentsPanel event handler declarations

////@end CExperimentsPanel event handler declarations

////@begin CExperimentsPanel member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CExperimentsPanel member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CExperimentsPanel member variables
    /// Control identifiers
    enum {
        ID_CEXPERIMENTSSPANEL = 10019,
        ID_WINDOW = 10020
    };
////@end CExperimentsPanel member variables
private:
    CSerialObject* m_Object;
    CRef<CSerialObject> m_EditedFeat;
};

END_NCBI_SCOPE

#endif
    // _EXPERIMENTS_PANEL_H_
