/*  $Id: field_type_constants.cpp 43676 2019-08-14 14:28:05Z asztalos $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Andrea Asztalos
 */



#include <ncbi_pch.hpp>
#include <gui/widgets/edit/field_type_constants.hpp>


BEGIN_NCBI_SCOPE

const char* kDefinitionLineLabel = "Definition Line";
const char* kCommentDescriptorLabel = "Comment Descriptor";
const char* kGenomeProjectID = "Genome Project ID";
const char* kGenbankBlockKeyword = "Keyword";

const char* kFieldTypeSeqId = "SeqId";
const char* kFileSeqId = "File ID";
const char* kGeneralId = "General ID";
const char* kLocalId = "Local ID";
const char* kFlatFile = "GenBank FlatFile";
const char* kBankITComment = "BankIT Comment";
const char* kComment = "Comment";
const char* kTaxnameAfterBinomial = "Taxname after Binomial";

const char* kFieldTypeTaxname = "Taxname";
const char* kStructCommFieldValuePair = "Structured Comment Field";
const char* kStructCommDBName = "Structured Comment Database Name";
const char* kStructCommFieldName = "Structured Comment Field Name";

const char* kSubSourceNote = "note-subsource";
const char* kOrgModNote = "note-orgmod";
const char* kHost = "host";
const char* kNatHost = "nat-host";
const char* kAllNotes = "All notes";
const char* kAllPrimers = "All primers";
const char* kDbXref = "dbxref";

const char* kFwdPrimerName ="fwd-primer-name";
const char* kFwdPrimerSeq = "fwd-primer-seq";
const char* kRevPrimerName = "rev-primer-name";
const char* kRevPrimerSeq = "rev-primer-seq";

const char* kNewId = "New Sequence ID";
const char* kMoleculeType = "Molecule Type";
const char* kDefaultMoleculeType = "Genomic DNA";
const char* kTopology = "Topology";
const char* kLocation = "Location";
const char* kSequenceIdColLabel = "Seq-ID";

END_NCBI_SCOPE


