/*  $Id: single_cds_exception_panel.hpp 37148 2016-12-08 16:17:23Z filippov $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Colleen Bollin
 */
// Generated by DialogBlocks (unregistered), 22/12/2011 15:18:47

#ifndef _SINGLE_CDS_EXCEPTION_PANEL_H_
#define _SINGLE_CDS_EXCEPTION_PANEL_H_

#include <corelib/ncbistd.hpp>
#include <objects/seqfeat/Code_break.hpp>
#include <gui/widgets/edit/formattedqual_panel.hpp>

BEGIN_NCBI_SCOPE

////@begin control identifiers
#define SYMBOL_CSINGLECDSEXCEPTIONPANEL_STYLE wxTAB_TRAVERSAL
#define SYMBOL_CSINGLECDSEXCEPTIONPANEL_TITLE _("SingleCDSExceptionPanel")
#define SYMBOL_CSINGLECDSEXCEPTIONPANEL_IDNAME ID_CSINGLECDSEXCEPTIONPANEL
#define SYMBOL_CSINGLECDSEXCEPTIONPANEL_SIZE wxSize(400, 300)
#define SYMBOL_CSINGLECDSEXCEPTIONPANEL_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CSingleCDSExceptionPanel class declaration
 */

class CSingleCDSExceptionPanel: public CQualListItemPanel
{    
    DECLARE_DYNAMIC_CLASS( CSingleCDSExceptionPanel )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CSingleCDSExceptionPanel();
    CSingleCDSExceptionPanel( wxWindow* parent, objects::CCode_break& code_break, objects::CSeq_feat& feat, objects::CScope& scope, 
                              wxWindowID id = SYMBOL_CSINGLECDSEXCEPTIONPANEL_IDNAME, 
                              const wxPoint& pos = SYMBOL_CSINGLECDSEXCEPTIONPANEL_POSITION, 
                              const wxSize& size = SYMBOL_CSINGLECDSEXCEPTIONPANEL_SIZE, 
                              long style = SYMBOL_CSINGLECDSEXCEPTIONPANEL_STYLE );

    /// Creation
    bool Create( wxWindow* parent, 
        wxWindowID id = SYMBOL_CSINGLECDSEXCEPTIONPANEL_IDNAME, 
        const wxPoint& pos = SYMBOL_CSINGLECDSEXCEPTIONPANEL_POSITION, 
        const wxSize& size = SYMBOL_CSINGLECDSEXCEPTIONPANEL_SIZE, 
        long style = SYMBOL_CSINGLECDSEXCEPTIONPANEL_STYLE );

    /// Destructor
    ~CSingleCDSExceptionPanel();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

    virtual void GetDimensions(int *width, int *height);

    virtual bool TransferDataToWindow();
    virtual bool TransferDataFromWindow();
    void SetCodeBreak(CRef<objects::CCode_break> code_break);
    CRef<objects::CCode_break> GetCodeBreak();

////@begin CSingleCDSExceptionPanel event handler declarations

    /// wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_CHOICE14
    void OnChoice14Selected( wxCommandEvent& event );

////@end CSingleCDSExceptionPanel event handler declarations

////@begin CSingleCDSExceptionPanel member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CSingleCDSExceptionPanel member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CSingleCDSExceptionPanel member variables
    wxTextCtrl* m_AACtrl;
    wxChoice* m_AminoAcidCtrl;
    /// Control identifiers
    enum {
        ID_CSINGLECDSEXCEPTIONPANEL = 10104,
        ID_TEXTCTRL35 = 10105,
        ID_CHOICE14 = 10106
    };
////@end CSingleCDSExceptionPanel member variables
private:
    CRef< objects::CCode_break > m_CodeBreak;
    objects::CScope *m_Scope;
    CRef< objects::CSeq_feat> m_EditedFeat;
    
    vector<string> m_AminoAcidList;
    void x_SetAminoAcid ();
};

END_NCBI_SCOPE

#endif
    // _SINGLE_CDS_EXCEPTION_PANEL_H_
