/* pir_index.h
 *
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Name:  pir_index.h
 *
 * Author:  Sergey Bazhin
 *
 * File Description:
 * -----------------
 *      Defines PIR keywords.
 *
 */

// LCOV_EXCL_START
// Excluded per Mark's request on 12/14/2016
#define ParFlatPIR_ENTRY           0
#define ParFlatPIR_TITLE           1
#define ParFlatPIR_ALTERNATE_NAMES 2
#define ParFlatPIR_CONTAINS        3
#define ParFlatPIR_ORGANISM        4
#define ParFlatPIR_DATE            5
#define ParFlatPIR_ACCESSIONS      6
#define ParFlatPIR_REFERENCE       7
#define ParFlatPIR_COMMENT         8
#define ParFlatPIR_COMPLEX         9
#define ParFlatPIR_GENETICS        10
#define ParFlatPIR_FUNCTION        11
#define ParFlatPIR_CLASSIFICATION  12
#define ParFlatPIR_KEYWORDS        13
#define ParFlatPIR_FEATURE         14
#define ParFlatPIR_SUMMARY         15
#define ParFlatPIR_SEQUENCE        16
#define ParFlatPIR_END             17
// LCOV_EXCL_STOP
